/**@name LIBRARY: cryoGWT_constant_declarations.ctl

@author: Alexey Merezhin (BE/ICS)

Creation Date: Jan 2015

*/

// constant for import of CRYOGTW
const string CRYO_CRYOGTW_DPTYPE = "CRYOGTW";
const unsigned CRYO_CONFIG_CRYOGTW_LENGTH = 6;
const unsigned CRYO_CONFIG_CRYOGTW_DEVICE = 4;
const unsigned CRYO_CONFIG_CRYOGTW_FIPSEGMENT = 5;	// address of th liveCounter of the FIP network (VIRTUAL GTWY)
const unsigned CRYO_CONFIG_CRYOGTW_CIET_VERSION = 6; // User specification version

const unsigned CRYO_CRYOGTW_CHECKFESYSTEM_ALARM_LENGTH = 6;	// 5 parameters
const unsigned CRYO_CRYOGTW_CHECKFESYSTEM_ALARM_FRONTEND = 1;	// front-end type
const unsigned CRYO_CRYOGTW_CHECKFESYSTEM_ALARM_NAME = 2;	// name
const unsigned CRYO_CRYOGTW_CHECKFESYSTEM_ALARM_ADDRESS = 3;	// Address in front-end
const unsigned CRYO_CRYOGTW_CHECKFESYSTEM_ALARM_OKALARM = 4;	// true=alarm if value>10, false (default) = alarm if value<=10
const unsigned CRYO_CRYOGTW_CHECKFESYSTEM_ALARM_DESCRIPTION = 5;	// description
const unsigned CRYO_CRYOGTW_CHECKFESYSTEM_ALARM_CMWDEVICE = 6;	// description

const unsigned CRYO_CRYOGTW_SETFESYSTEM_ALARM_LENGTH = 13;	// 13 parameters

const unsigned CRYO_CRYOGTW_SETFESYSTEM_ALARM_NAME = 1;	// name
const unsigned CRYO_CRYOGTW_SETFESYSTEM_ALARM_ADDRESS = 2;	// Address in front-end
const unsigned CRYO_CRYOGTW_SETFESYSTEM_ALARM_OKALARM = 3;	// true=alarm if value>10, false (default) = alarm if value<=10
const unsigned CRYO_CRYOGTW_SETFESYSTEM_ALARM_DESCRIPTION = 4;	// description
const unsigned CRYO_CRYOGTW_SETFESYSTEM_ALARM_CMWDEVICE = 5;	// device

const unsigned CRYO_CRYOGTW_FESYSTEMALARM_DEVICENAME = 6;
const unsigned CRYO_CRYOGTW_FESYSTEMALARM_PLCNAME = 7;
const unsigned CRYO_CRYOGTW_FESYSTEMALARM_TYPE = 8;
const unsigned CRYO_CRYOGTW_FESYSTEMALARM_PLCNUMBER = 9;
const unsigned CRYO_CRYOGTW_FESYSTEMALARM_DRIVER = 10;
const unsigned CRYO_CRYOGTW_FESYSTEMALARM_EVENT16 = 11;
const unsigned CRYO_CRYOGTW_FESYSTEMALARM_ARCHIVE = 12;

// constants for cryoGWT addressing
const string CRYO_CRYOGTW_ADDRESS_INPUT_SUFIX = "/acqStamp:longlongnano";

// constant for CRYOGTW system integrity
const string c_cietSystemIntegrity_CRYOGTW = "CRYOGTW_";
const string UN_SYSTEM_INTEGRITY_CRYOGTW = "CRYOGTW";
const string c_cietSystemIntegrity_CRYOGTW_Time_callback = "cietSystemIntegrity_CRYOGTWTimeCallback";
const int c_cietSystemIntegrity_defaultCRYOGTWCheckingDelay = 10; // default value for the checking in sec.

// global declaration for systemIntegrity
global dyn_string g_cietSystemIntegrity_CRYOGTW_DSList; // list of the CRYOGTW-DS dp checked
global dyn_int g_cietSystemIntegrity_CRYOGTW_DSThreadId; // list of the CRYOGTW-DS thread Id checking the counter
global int g_cietSystemIntegrity_CRYOGTWCheckingDelay;

const int CRYO_SYSTEM_INTEGRITY_ALARM_LIMIT = 10;
