#uses "unMessageText.ctl"
#uses "unCMWServerDeprecated.ctl"
#uses "fwGeneral/fwGeneral.ctl"
#uses "unCoreLHCServices.ctl"
#uses "unSystemIntegrity.ctl"

/**@file

// unCMWServerDeprecated.ctl
This library contains all the deprecated functions from unSystemIntegrity_CMWServer.

@par Creation Date
  31/12/2018

@author
  Leonid Kopylov (BE-ICS-FD)
*/

/** @name Constants */
//@(
/**
* @deprecated 2018-12-31
*/
const string c_unSystemIntegrity_CMWServer_callback = "_unSystemIntegrity_CMWServerCallback";
//@)

/** @name Global variables
*/
//@{
global dyn_string g_unSystemIntegrity_CMWServerList; ///< list of the CMWServer dp checked @deprecated 2018-12-31
//CMWServer
global dyn_string g_dsCMWServer_Name;				///< Manager List @deprecated 2018-12-31
global dyn_int g_diCMWServer_Message;				///< Message Value for Managers @deprecated 2018-12-31
global dyn_int g_diCMWServer_PVSS;					///< PVSS State in Console for Managers @deprecated 2018-12-31
global dyn_int g_diCMWServer_Command;				///< Command Value for Managers @deprecated 2018-12-31
global dyn_int g_diCMWServer_State;					///< Status Value for Managers @deprecated 2018-12-31
global dyn_int g_diCMWServer_Period;				///< Period to check man_Num @deprecated 2018-12-31
global dyn_int g_diCMWServer_Api;					///< Api Connection @deprecated 2018-12-31
dyn_string g_dsCMWServer_Thread;					///< Thread started @deprecated 2018-12-31
dyn_int g_diOld_alarm_CMWServer;					///< Old Alarm State for Manager @deprecated 2018-12-31
//@}

/** @name Public functions */
//@{

//------------------------------------------------------------------------------------------------------------------------

// _unSystemIntegrity_CMWServerCallback
/**
Purpose:
Callback function for the command interface. This function is called when the system alarm is enabled for this device.

  @param sDp1 string, input, data point name
  @param iMessageOut int, input, Message from CMWServer

Usage: Internal

PVSS manager usage: CTRL (WCCOACTRL)

Constraints:
	. PVSS version: 2.12.1 
	. operating system: W2000, NT and Linux, but tested only under W2000 and Linux.
	. distributed system: yes.

  @deprecated 2018-12-31
*/
_unSystemIntegrity_CMWServerCallback(string sDp1, int iMessageOut)
{
FWDEPRECATED();
int iStatus, iPosition, value, iRes, iNum;
string sManager, sNum;
dyn_string exceptionInfo;

//DebugN("LHCCMWServer", "_unSystemIntegrity_CMWServerCallback");
	
	sManager = substr(sDp1, strpos(sDp1, c_CMWServer_Pattern), strlen(c_CMWServer_Pattern) + 2);
	
	//1. Save State
	unCMWServer_getPosition(sManager, iPosition);
	
	//2. Gathering Status
	g_diCMWServer_Message[iPosition]=iMessageOut;
	
	//3. Get State
	unCMWServer_getStatus(iPosition, iStatus);
	
	if (iStatus!=0)	//Error or Warning
		{
		switch(g_diCMWServer_PVSS[iPosition])
			{
			case 0:									//Manager stopped
				value = c_Stopped;						
				break;
		
			case 1:									//Manager Started
				value = iMessageOut;
				break;
				
			case 2:									//Error with Manager (ie: Blocked)
				value = c_Blocked;		
				break;
			
			default:	
				value = 1300;		
			}
		}	
	else  // Manager OK
		value = c_unSystemIntegrity_no_alarm_value;	
	
	if (g_diOld_alarm_CMWServer[iPosition]!=value)
		{
		g_diOld_alarm_CMWServer[iPosition]=value;
		
		sNum=substr(sManager, strpos(sManager, c_CMWServer_Pattern) + strlen(c_CMWServer_Pattern));
		sscanf(sNum,"%d",iNum);
						
		if (dpExists(c_unSystemAlarm_dpPattern + CMWServer_pattern + iNum + ".alarm"))
			iRes=dpSet(c_unSystemAlarm_dpPattern + CMWServer_pattern + iNum + ".alarm", value);	
		else
			{
			fwException_raise(exceptionInfo, "ERROR", 
						"_unSystemIntegrity_LHCLoggingCallback(): " + getCatStr("unSystemIntegrity", "WRONG_ALARM_DPE") + CMWServer_pattern + iNum + " value = " + value,"");
						
			if(isFunctionDefined("unMessageText_sendException")) 
				unMessageText_sendException("*", "*", "SystemIntegrity", "user", "*", exceptionInfo);
			}
		}			
}

//@}
